#ifndef _WIN32SDK_COMMON_H
#define _WIN32SDK_COMMON_H

#ifdef HPRT_FOR_PB_ENV_EXPORTS
#define HPRT_SDK_API
#define CALL_STACK __stdcall
#else
#ifdef __cplusplus
#define HPRT_SDK_API extern "C" __declspec(dllexport)
#define CALL_STACK __cdecl
#else
#define HPRT_SDK_API __declspec(dllexport)
#define CALL_STACK __cdecl
#endif
#endif

HPRT_SDK_API void CALL_STACK PrtFormatErrorA(int errorNo,int langid,unsigned char* buf,int pos,int bufSize);
HPRT_SDK_API void CALL_STACK PrtFormatErrorW(int errorNo,int langid,unsigned char* buf,int pos,int bufSize);
HPRT_SDK_API int CALL_STACK PrtPrinterCreatorA( void** phandle,const char* model); 
HPRT_SDK_API int CALL_STACK PrtPrinterCreatorW( void** phandle,const wchar_t* model);
HPRT_SDK_API void* CALL_STACK PrtPrinterCreatorS(char* model);
HPRT_SDK_API int CALL_STACK PrtPrinterDestroy( void* handle);

HPRT_SDK_API int CALL_STACK PrtPortOpenA(void* handle,const char* ioSettings);
HPRT_SDK_API int CALL_STACK PrtPortOpenW(void* handle,const wchar_t* ioSettings);
HPRT_SDK_API int CALL_STACK PrtPortClose(void* handle);
HPRT_SDK_API int CALL_STACK PrtPrinterInitialize(void* handle);

HPRT_SDK_API int CALL_STACK PrtDirectIO(void* handle,unsigned char* writedata,unsigned int writeNum,unsigned char* readData,unsigned int readNum,unsigned int* preadedNum);
HPRT_SDK_API int CALL_STACK PrtWriteData(void* handle, unsigned char* writeData, unsigned int writeNum);
HPRT_SDK_API int CALL_STACK PrtReadData(void* handle, unsigned char* readData, unsigned int readNum, unsigned int* preadedNum);
HPRT_SDK_API int CALL_STACK PrtReadDataEOF(void* handle, unsigned char* readData, unsigned int offSet, unsigned int bufLength, unsigned char soh, unsigned char eof,unsigned int* preadedNum);
HPRT_SDK_API void* CALL_STACK PrtOpenPrinterDriverS(char* driverName);
HPRT_SDK_API int CALL_STACK PrtClosePrinterDriver(void* hPrinter);

#endif