#ifndef HPRT_PRINTER_WIN32_ZPL_SDK_H
#define HPRT_PRINTER_WIN32_ZPL_SDK_H

#ifdef HPRT_FOR_PB_ENV_EXPORTS
#define HPRT_SDK_API
#define CALL_STACK __stdcall
#else
#ifdef __cplusplus
#define HPRT_SDK_API extern "C" __declspec(dllexport)
#define CALL_STACK __cdecl
#else
#define HPRT_SDK_API __declspec(dllexport)
#define CALL_STACK __cdecl
#endif
#endif

HPRT_SDK_API int CALL_STACK TSPL_SelfTest(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_BitMapW(void* handle, int x_pos, int y_pos, int mode, const wchar_t* filename);
HPRT_SDK_API int CALL_STACK TSPL_BitMapA(void* handle, int x_pos, int y_pos, int mode, const char* filename);
HPRT_SDK_API int CALL_STACK TSPL_Setup(void* handle, int label_width, int label_height, int speed, int density, int gap, int offset);
HPRT_SDK_API int CALL_STACK TSPL_ClearBuffer(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_Box(void* handle, int x_start, int y_start, int x_end, int y_end, int thickness);
HPRT_SDK_API int CALL_STACK TSPL_BarCode(void* handle, int x_pos, int y_pos, int code_type, int height, int readable, int rotation, int narrow, int wide, const char* code_data);
HPRT_SDK_API int CALL_STACK TSPL_QrCode(void* handle, int x_pos, int y_pos, int ecc_level, int width, int mode, int rotation, int model, int mask, const char* data);
HPRT_SDK_API int CALL_STACK TSPL_Text(void* handle, int x_pos, int y_pos, int font, int rotation, int x_multiplication, int y_multiplication, const char* content);
HPRT_SDK_API int CALL_STACK TSPL_Print(void* handle, int num, int copies);
HPRT_SDK_API int CALL_STACK TSPL_FormFeed(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_SetTear(void* handle, int on_off);
HPRT_SDK_API int CALL_STACK TSPL_Offset(void* handle, int distance);
HPRT_SDK_API int CALL_STACK TSPL_Direction(void* handle, int direction);
HPRT_SDK_API int CALL_STACK TSPL_Feed(void* handle, int len);
HPRT_SDK_API int CALL_STACK TSPL_Home(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_Learn(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_GetDllVersion(void* handle);
HPRT_SDK_API int CALL_STACK TSPL_GetSN(void* handle, char* sn);

#endif