unit PrinterLib;

interface
function PrinterCreator(model:string):Boolean;
function PortOpen(portSetting:string): Integer;
function PortClose(): Integer;
function selftest():Integer;
function formfeed():Integer;
function setup(label_width:Integer;label_height:Integer;speed:Integer;density:Integer;type_tspl:integer;gap:Integer; offset:Integer):Integer;
function printertext(x_pos:Integer;y_pos:Integer;font:Integer; rotation:Integer;x_multiplication:Integer;y_multiplication:Integer; content:ansistring):Integer;
function priterbarcode(x_pos:Integer;y_pos:Integer;code_type:Integer;height:Integer;readable:Integer;rotation:Integer;narrow:Integer; wide:Integer;code_data:ansistring):Integer;
function printerprint(num:Integer; copies:Integer): Integer;
function printerqrcode(x_pos:Integer;y_pos:Integer;ecc_level:Integer;width:Integer;mode:Integer;rotation:Integer;model:Integer; mask:Integer;data:ansistring): Integer;
function printerbitmap(x_pos:Integer;y_pos:Integer;mode:Integer;filename:ansiString):Integer;
function printerbox(x_start:Integer; y_start:Integer;x_end:Integer; y_end:Integer;thickness:Integer): Integer;
function printerdirection(direction: Integer): Integer;
function clearbuff():integer;
var
//Alignment
ALIGNMENT_LEFT:Integer=0;
ALIGNMENT_CENTER:Integer=1;
ALIGNMENT_RIGHT:Integer=2;
//QR Code Type
SYMBOL_QRCODE1:Integer=103;
SYMBOL_QRCODE2:Integer=104;
//Image ScaleMode
PRINT_IMAGE_NORMAL:Integer=0;
PRINT_IMAGE_DOUBLE_WIDTH:Integer=1;
PRINT_IMAGE_DOUBLE_HEIGHT:Integer=2;
PRINT_IMAGE_QUADRUPLE:Integer=3;
//Error Code
E_SUCCESS:Integer=0;
E_BAD_HANDLE:Integer=-6;
//printer
printer:Pointer;
errorNo:Integer=0;

implementation
function PrtPrinterCreatorW(printer: PPointer;model:string): Integer; cdecl ; external 'TSPL_SDK.dll';
function PrtPortOpenW(printer: Pointer;portSetting:string): Integer; cdecl ; external 'TSPL_SDK.dll';
function PrtPortClose(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_SelfTest(printer:Pointer):Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_BitMapA(printer:Pointer;x_pos:Integer;y_pos:Integer;mode:Integer;filename:ansistring):Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Setup(printer:Pointer;label_width:Integer;label_height:Integer;speed:Integer;density:Integer;type_tspl:integer;gap:Integer; offset:Integer):Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_ClearBuffer(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Box(printer:Pointer;x_start:Integer; y_start:Integer;x_end:Integer; y_end:Integer;thickness:Integer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_BarCode(printer:Pointer;x_pos:Integer;y_pos:Integer;code_type:Integer;height:Integer;readable:Integer;rotation:Integer;narrow:Integer; wide:Integer;code_data:ansistring):Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_QrCode(printer:Pointer;x_pos:Integer;y_pos:Integer;ecc_level:Integer;width:Integer;mode:Integer;rotation:Integer;model:Integer; mask:Integer;data:ansistring): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Text(printer:Pointer;x_pos:Integer;y_pos:Integer;font:Integer; rotation:Integer;x_multiplication:Integer;y_multiplication:Integer; content:ansiString ): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Print(printer:Pointer;num:Integer; copies:Integer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_FormFeed(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_SetTear(printer:Pointer;on_off: Integer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Direction(printer:Pointer;direction: Integer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Feed(printer:Pointer;len: Integer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Home(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_Learn(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_GetDllVersion(printer:Pointer): Integer; cdecl ; external 'TSPL_SDK.dll';
function TSPL_GetSN(printer:Pointer;sn:string): Integer; cdecl ; external 'TSPL_SDK.dll';


function PrinterCreator(model:string):Boolean;
begin
  printer:=nil;
  errorNo:=PrtPrinterCreatorW(@printer,model);
  if(E_SUCCESS=errorNo) then
  begin
    Result :=True;
  end
  else
  begin
    Result := False;
  end;
end;

function PortOpen(portSetting:string): Integer;
begin
  if (printer <> PtrToNil) then
  begin
    Result:= PrtPortOpenW(printer, 'USB');
  end
  else
  begin
    Result := E_BAD_HANDLE;
  end;
end;

function PortClose(): Integer;
begin
  Result := PrtPortClose(printer);
end;

function selftest():Integer;
begin
     Result:=TSPL_SelfTest(printer);
end;

function formfeed():Integer;
begin
  Result:=TSPL_FormFeed(printer);
end;

   function printertext(x_pos:Integer;y_pos:Integer;font:Integer; rotation:Integer;x_multiplication:Integer;y_multiplication:Integer; content:ansistring):Integer;
   begin
   Result:=TSPL_Text(printer,x_pos,y_pos,font,rotation, x_multiplication,y_multiplication, content);
   end;

   function priterbarcode(x_pos:Integer;y_pos:Integer;code_type:Integer;height:Integer;readable:Integer;rotation:Integer;narrow:Integer; wide:Integer;code_data:ansistring):Integer;
   begin
       Result:= TSPL_BarCode(printer,x_pos,y_pos,code_type,height,readable,rotation,narrow,wide,code_data);
   end;

   function printerprint(num:Integer;copies:Integer): Integer;
   begin
       Result:=TSPL_Print(printer,num,copies);
   end;
            function setup(label_width:Integer;label_height:Integer;speed:Integer;density:Integer;type_tspl:integer;gap:Integer; offset:Integer):Integer;
            begin
               Result:= TSPL_Setup(printer,label_width,label_height,speed,density,type_tspl,gap,offset);
            end;

   function printerqrcode(x_pos:Integer;y_pos:Integer;ecc_level:Integer;width:Integer;mode:Integer;rotation:Integer;model:Integer; mask:Integer;data:ansistring): Integer;
   begin
        Result:=TSPL_QrCode(printer,x_pos, y_pos,ecc_level,width,mode, rotation, model, mask, data);
   end;

   function printerbitmap(x_pos:Integer;y_pos:Integer;mode:Integer;filename:ansistring):Integer;
   begin
        Result:= TSPL_BitMapA(printer,x_pos,y_pos,mode,filename);
   end;

   function printerbox(x_start:Integer; y_start:Integer;x_end:Integer; y_end:Integer;thickness:Integer): Integer;
   begin
        Result:= TSPL_Box(printer,x_start, y_start, x_end, y_end, thickness);
   end;
   function printerdirection(direction: Integer): Integer;
   begin
      Result:= TSPL_Direction(printer,direction);
   end;
   function clearbuff():integer;
   begin
     Result:=  TSPL_ClearBuffer(printer);
   end;

end.
